<?php
namespace Gateway;
include('Connection.php');

Class UserGateway{
    private Connection $con;

    public function __construct(Connection $con){
        $this->con=$con;
    }

    public function insert(string $username,string $email,string $passwd):string{

        // récupération id
        $query='SELECT id_user FROM Users WHERE id_user >= ALL (SELECT id_user FROM Users);';
        $this->con->executeQuery($query);
        $result=$this->con->getResults();
        foreach($result as $row){
            $id=$row['id_user'] + 1;
        }
        // insertion user 
        $query='INSERT INTO Users VALUES (:id,:username,:email,:passwd,CURRENT_DATE,false);';
        $this->con->executeQuery($query,array(':id' => array($id,PDO::PARAM_STR),':username' => array($u->username,PDO::PARAM_STR),':email' => array($u->email,PDO::PARAM_STR),':passwd' => array($u->passwd,PDO::PARAM_STR)));
        return $id;
    }
    
    public function delete(string $id) : bool{

        // supretion user 
        $query='DELETE FROM Users WHERE id_user = :id;';
        return $this->con->executeQuery($query,array(':id' => array($id,PDO::PARAM_STR)));
    }

    public function getFavorite(string $id):array{

        //obtention favoris d'un user
        $query='SELECT * FROM Quote WHERE id_quote IN (SELECT id_quote IN Favorite f JOIN User u ON u.id_user = f.user WHERE id_user = :id);';
        $this->con->executeQuery($query,array(':id' => array($id,PDO::PARAM_STR)));
        $result=$this->con->getResults();
        return $result;
    }

}
?>
